﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MollaScript : MonoBehaviour {

	public ParticleScript pa, pb;
	public float K = 100.0f;
	public float restLen = 0.0f;

	// Use this for initialization
	void Start () {
		restLen = Vector3.Distance (pa.transform.position, pb.transform.position);
	}

	// solo per esercizio: trovare la rotazione minima che porta fromV in toV
	Quaternion MiaFromToRotation( Vector3 fromV, Vector3 toV ){
		Vector3 asse = Vector3.Cross (fromV.normalized, toV.normalized);

		float coseno = Vector3.Dot (fromV.normalized, toV.normalized);
		float seno = asse.magnitude;
		float angolo = Mathf.Atan2 (seno, coseno);
		return Quaternion.AngleAxis ( (float)(Mathf.Rad2Deg * angolo), asse);
	}

	// update per il rendering
	void Update () {
		
		float distAB = Vector3.Distance (pa.transform.position, pb.transform.position);

		transform.localPosition = (pa.transform.position + pb.transform.position) / 2;
		transform.localScale = new Vector3 (0.25f, distAB / 2, 0.25f);

		Vector3 aMenoB = pa.transform.position - pb.transform.position;
		transform.localRotation = MiaFromToRotation (Vector3.up, aMenoB);
	}

	void FixedUpdate(){
		Vector3 d = pb.transform.position - pa.transform.position;
		Vector3 f = d  * (K * (d.magnitude - restLen) / d.magnitude);
		pa.forze += f;
		pb.forze -= f;
	}
}
